import { AutocompleteSetters, AutocompleteSource as AutocompleteCoreSource, AutocompleteState, GetSourcesParams, PublicAutocompleteOptions as PublicAutocompleteCoreOptions } from '@francoischalifour/autocomplete-core';
declare type Template<TParams> = (params: TParams) => string | void;
declare type AutocompleteSource<TItem> = AutocompleteCoreSource<TItem> & {
    templates: {
        item: Template<{
            root: HTMLElement;
            item: TItem;
            state: AutocompleteState<TItem>;
        }>;
        header?: Template<{
            root: HTMLElement;
            state: AutocompleteState<TItem>;
        }>;
        footer?: Template<{
            root: HTMLElement;
            state: AutocompleteState<TItem>;
        }>;
    };
};
declare type GetSources<TItem> = (params: GetSourcesParams<TItem>) => Promise<Array<AutocompleteSource<TItem>>>;
export interface AutocompleteOptions<TItem> extends PublicAutocompleteCoreOptions<TItem> {
    container: string | HTMLElement;
    render(params: {
        root: HTMLElement;
        sections: HTMLElement[];
        state: AutocompleteState<TItem>;
    }): void;
    getSources: GetSources<TItem>;
}
export interface AutocompleteApi<TItem> extends AutocompleteSetters<TItem> {
    /**
     * Triggers a search to refresh the state.
     */
    refresh(): Promise<void>;
}
export declare function autocomplete<TItem>({ container, render: renderDropdown, ...props }: AutocompleteOptions<TItem>): AutocompleteApi<TItem>;
export {};
