function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { createAutocomplete } from '@francoischalifour/autocomplete-core';
import { getHTMLElement } from './getHTMLElement';
import { setProperties } from './setProperties';
/**
 * Renders the template in the root element.
 *
 * If the template is a string, we update the HTML of the root to this string.
 * If the template is empty, it means that users manipulated the root element
 * DOM programatically (e.g., attached events, used a renderer like Preact), so
 * this needs to be a noop.
 */

function renderTemplate(template, root) {
  if (typeof template === 'string') {
    root.innerHTML = template;
  }
}

function defaultRender(_ref) {
  var root = _ref.root,
      sections = _ref.sections;

  var _iterator = _createForOfIteratorHelper(sections),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var section = _step.value;
      root.appendChild(section);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}

export function autocomplete(_ref2) {
  var container = _ref2.container,
      _ref2$render = _ref2.render,
      renderDropdown = _ref2$render === void 0 ? defaultRender : _ref2$render,
      props = _objectWithoutProperties(_ref2, ["container", "render"]);

  var containerElement = getHTMLElement(container);
  var inputWrapper = document.createElement('div');
  var input = document.createElement('input');
  var root = document.createElement('div');
  var form = document.createElement('form');
  var label = document.createElement('label');
  var resetButton = document.createElement('button');
  var dropdown = document.createElement('div');
  var autocomplete = createAutocomplete(_objectSpread({
    onStateChange: function onStateChange(options) {
      var state = options.state;
      render(state);

      if (props.onStateChange) {
        props.onStateChange(options);
      }
    }
  }, props));
  var environmentProps = autocomplete.getEnvironmentProps({
    searchBoxElement: form,
    dropdownElement: dropdown,
    inputElement: input
  });
  setProperties(window, environmentProps);
  var rootProps = autocomplete.getRootProps();
  setProperties(root, rootProps);
  root.classList.add('aa-Autocomplete');
  var formProps = autocomplete.getFormProps({
    inputElement: input
  });
  setProperties(form, formProps);
  form.classList.add('aa-Form');
  var labelProps = autocomplete.getLabelProps();
  setProperties(label, labelProps);
  label.textContent = 'Search items';
  inputWrapper.classList.add('aa-InputWrapper');
  var inputProps = autocomplete.getInputProps({
    inputElement: input
  });
  setProperties(input, inputProps);
  input.classList.add('aa-Input');
  var completion = document.createElement('span');
  completion.classList.add('aa-Completion');
  resetButton.setAttribute('type', 'reset');
  resetButton.textContent = 'ｘ';
  resetButton.addEventListener('click', formProps.onReset);
  var dropdownProps = autocomplete.getDropdownProps({});
  setProperties(dropdown, dropdownProps);
  dropdown.classList.add('aa-Dropdown');
  dropdown.setAttribute('hidden', '');

  function render(state) {
    input.value = state.query;

    if (props.enableCompletion) {
      completion.textContent = state.completion;
    }

    dropdown.innerHTML = '';

    if (state.isOpen) {
      dropdown.removeAttribute('hidden');
    } else {
      dropdown.setAttribute('hidden', '');
      return;
    }

    if (state.status === 'stalled') {
      dropdown.classList.add('aa-Dropdown--stalled');
    } else {
      dropdown.classList.remove('aa-Dropdown--stalled');
    }

    var sections = state.suggestions.map(function (suggestion) {
      var items = suggestion.items;
      var source = suggestion.source;
      var section = document.createElement('section');

      if (source.templates.header) {
        var header = document.createElement('header');
        renderTemplate(source.templates.header({
          root: header,
          state: state
        }), header);
        section.appendChild(header);
      }

      if (items.length > 0) {
        var menu = document.createElement('ul');
        var menuProps = autocomplete.getMenuProps();
        setProperties(menu, menuProps);
        var menuItems = items.map(function (item) {
          var li = document.createElement('li');
          var itemProps = autocomplete.getItemProps({
            item: item,
            source: source
          });
          setProperties(li, itemProps);
          renderTemplate(source.templates.item({
            root: li,
            item: item,
            state: state
          }), li);
          return li;
        });

        var _iterator2 = _createForOfIteratorHelper(menuItems),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var menuItem = _step2.value;
            menu.appendChild(menuItem);
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        section.appendChild(menu);
      }

      if (source.templates.footer) {
        var footer = document.createElement('footer');
        renderTemplate(source.templates.footer({
          root: footer,
          state: state
        }), footer);
        section.appendChild(footer);
      }

      return section;
    });
    renderDropdown({
      root: dropdown,
      sections: sections,
      state: state
    });
  }

  form.appendChild(label);

  if (props.enableCompletion) {
    inputWrapper.appendChild(completion);
  }

  inputWrapper.appendChild(input);
  inputWrapper.appendChild(resetButton);
  form.appendChild(inputWrapper);
  root.appendChild(form);
  root.appendChild(dropdown);
  containerElement.appendChild(root);
  return {
    setHighlightedIndex: autocomplete.setHighlightedIndex,
    setQuery: autocomplete.setQuery,
    setSuggestions: autocomplete.setSuggestions,
    setIsOpen: autocomplete.setIsOpen,
    setStatus: autocomplete.setStatus,
    setContext: autocomplete.setContext,
    refresh: autocomplete.refresh
  };
}