import { parseHighlightedAttribute, parseReverseHighlightedAttribute } from '@francoischalifour/autocomplete-preset-algolia';
export function highlightItem(_ref) {
  var item = _ref.item,
      attribute = _ref.attribute,
      _ref$highlightPreTag = _ref.highlightPreTag,
      highlightPreTag = _ref$highlightPreTag === void 0 ? '<mark>' : _ref$highlightPreTag,
      _ref$highlightPostTag = _ref.highlightPostTag,
      highlightPostTag = _ref$highlightPostTag === void 0 ? '</mark>' : _ref$highlightPostTag;
  return parseHighlightedAttribute({
    hit: item,
    attribute: attribute,
    highlightPreTag: highlightPreTag,
    highlightPostTag: highlightPostTag
  }).reduce(function (acc, current) {
    return acc + (current.isHighlighted ? "".concat(highlightPreTag).concat(current.value).concat(highlightPostTag) : current.value);
  }, '');
}
export function reverseHighlightItem(_ref2) {
  var item = _ref2.item,
      attribute = _ref2.attribute,
      _ref2$highlightPreTag = _ref2.highlightPreTag,
      highlightPreTag = _ref2$highlightPreTag === void 0 ? '<mark>' : _ref2$highlightPreTag,
      _ref2$highlightPostTa = _ref2.highlightPostTag,
      highlightPostTag = _ref2$highlightPostTa === void 0 ? '</mark>' : _ref2$highlightPostTa;
  return parseReverseHighlightedAttribute({
    hit: item,
    attribute: attribute,
    highlightPreTag: highlightPreTag,
    highlightPostTag: highlightPostTag
  }).reduce(function (acc, current) {
    return acc + (current.isHighlighted ? "".concat(highlightPreTag).concat(current.value).concat(highlightPostTag) : current.value);
  }, '');
}